Index: branches/LearningClassifierSystems/HeuristicLab.Algorithms.DataAnalysis/3.4/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Algorithms.DataAnalysis/3.4/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Algorithms.DataAnalysis/3.4/Plugin.cs.frame	(revision 9605)
@@ -37,8 +37,10 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.ConditionActionEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.RealVectorEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.4")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators.LCS", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
Index: branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs	(revision 9605)
@@ -201,6 +201,9 @@
       get { return (VariableCreator)RandomCreator.Successor; }
     }
+    private Placeholder InitialDefaultRuleExecution {
+      get { return (Placeholder)VariableCreator.Successor; }
+    }
     private Placeholder MDLIterationPlaceholder {
-      get { return (Placeholder)VariableCreator.Successor; }
+      get { return (Placeholder)InitialDefaultRuleExecution.Successor; }
     }
     private ILASOperator ILASOperator {
@@ -210,6 +213,6 @@
       get { return (InitializeDiscretizersOperator)ILASOperator.Successor; }
     }
-    private SolutionsCreator SolutionsCreator {
-      get { return (SolutionsCreator)InitializeDiscretizers.Successor; }
+    private NicheSolutionCreator SolutionsCreator {
+      get { return (NicheSolutionCreator)InitializeDiscretizers.Successor; }
     }
     private GAssistMainLoop GeneticAlgorithmMainLoop {
@@ -255,8 +258,9 @@
       RandomCreator randomCreator = new RandomCreator();
       VariableCreator variableCreator = new VariableCreator();
+      Placeholder initialDefaultRuleExecution = new Placeholder();
       Placeholder mdlIterationPlaceholder = new Placeholder();
       ILASOperator ilasOperator = new ILASOperator();
       InitializeDiscretizersOperator initializeDiscretizers = new InitializeDiscretizersOperator();
-      SolutionsCreator solutionsCreator = new SolutionsCreator();
+      NicheSolutionCreator solutionsCreator = new NicheSolutionCreator();
       SubScopesCounter subScopesCounter = new SubScopesCounter();
       ResultsCollector resultsCollector = new ResultsCollector();
@@ -272,5 +276,9 @@
 
       variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Generations", new IntValue(0))); // Class GAssistMainLoop expects this to be called Generations
-      variableCreator.Successor = mdlIterationPlaceholder;
+      variableCreator.Successor = initialDefaultRuleExecution;
+
+      initialDefaultRuleExecution.Name = "Initial Default Rule Execution";
+      initialDefaultRuleExecution.OperatorParameter.ActualName = DefaultRuleParameter.Name;
+      initialDefaultRuleExecution.Successor = mdlIterationPlaceholder;
 
       mdlIterationPlaceholder.Name = "MDL Iteration Operator";
@@ -315,6 +323,5 @@
       foreach (INichingSingleObjectiveSelector selector in ApplicationManager.Manager.GetInstances<INichingSingleObjectiveSelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name))
         SelectorParameter.ValidValues.Add(selector);
-      //INichingSingleObjectiveSelector proportionalSelector = SelectorParameter.ValidValues.FirstOrDefault(x => x.GetType().Name.Equals("ProportionalSelector"));
-      //if (proportionalSelector != null) SelectorParameter.Value = proportionalSelector;
+
       ParameterizeSelectors();
 
@@ -369,10 +376,10 @@
       SpecialStages.Operators.Clear();
       var splitOperator = new SplitOperator();
-      splitOperator.ProbabilityParameter.ActualName = "SplitProbability";
+      splitOperator.ProbabilityParameter.ActualName = SplitProbabilityParameter.Name;
       //change
       splitOperator.IndividualParameter.ActualName = "DecisionList";
       SpecialStages.Operators.Add(splitOperator);
       var mergeOperator = new MergeOperator();
-      mergeOperator.ProbabilityParameter.ActualName = "MergeProbability";
+      mergeOperator.ProbabilityParameter.ActualName = MergeProbabilityParameter.Name;
       //change
       mergeOperator.IndividualParameter.ActualName = "DecisionList";
@@ -381,5 +388,5 @@
       reinitializeOperator.ProbabilityParameter.ActualName = "ReinitializeProbability";
       reinitializeOperator.DiscretizersParameter.ActualName = "Discretizers";
-      reinitializeOperator.OneProbabilityParameter.ActualName = "OneProbability";
+      reinitializeOperator.OneProbabilityParameter.ActualName = OneProbabilityParameter.Name;
       //change
       reinitializeOperator.IndividualParameter.ActualName = "DecisionList";
@@ -508,6 +515,7 @@
       SolutionsCreator.EvaluatorParameter.ActualName = Problem.EvaluatorParameter.Name;
       SolutionsCreator.SolutionCreatorParameter.ActualName = Problem.SolutionCreatorParameter.Name;
+      SolutionsCreator.GAssistNichesProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
       // change!
-      ((IGAssistIndividualCreator)Problem.SolutionCreatorParameter.ActualValue).DiscretizersParameter.ActualName = "Discretizers";
+      ((IGAssistSolutionCreator)Problem.SolutionCreatorParameter.ActualValue).DiscretizersParameter.ActualName = "Discretizers";
     }
     private void ParameterizeGeneticAlgorithmMainLoop() {
@@ -536,7 +544,8 @@
         selector.ParentsPerChildParameter.Value = new IntValue(2);
         ParameterizeStochasticOperator(selector);
+        ParameterizeIterationBasedOperators(selector);
       }
       if (Problem != null) {
-        foreach (INichingSingleObjectiveSelector selector in SelectorParameter.ValidValues.OfType<INichingSingleObjectiveSelector>()) {
+        foreach (INichingSingleObjectiveSelector selector in SelectorParameter.ValidValues) {
           selector.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
           selector.MaximizationParameter.Hidden = true;
@@ -547,4 +556,7 @@
           //change
           selector.IndividualParameter.ActualName = "DecisionList";
+        }
+        foreach (IHierarchicalSingleObjectiveSelector selector in SelectorParameter.ValidValues.OfType<IHierarchicalSingleObjectiveSelector>()) {
+          selector.LengthParameter.ActualName = Problem.Evaluator.LengthParameter.ActualName;
         }
       }
@@ -595,6 +607,8 @@
         else oldDefaultRule = null;
       }
-      if (oldDefaultRule == null && defaultdefaultRule != null)
+      if (oldDefaultRule == null && defaultdefaultRule != null) {
         DefaultRuleParameter.Value = defaultdefaultRule;
+        SolutionsCreator.NichingParameter.ActualName = defaultdefaultRule.NichingParameter.ActualName;
+      }
     }
     private void UpdateCrossovers() {
Index: branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/Plugin.cs.frame	(revision 9605)
@@ -25,8 +25,18 @@
   [Plugin("HeuristicLab.Algorithms.GAssist", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.GAssist-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators.LCS", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabAlgorithmsGAssistPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/Plugin.cs.frame	(revision 9605)
@@ -24,15 +24,19 @@
 namespace HeuristicLab.Algorithms.LearningClassifierSystems {
   [Plugin("HeuristicLab.Algorithms.LearningClassifierSystems", "3.3.7.$WCREV$")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginFile("HeuristicLab.Algorithms.LearningClassifierSystems-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
-  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances.DataAnalysis", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.ConditionActionEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Operators.LCS", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabAlgorithmsLearningClassifierSystemsPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Plugin.cs.frame	(revision 9605)
@@ -25,14 +25,15 @@
   [Plugin("HeuristicLab.Encodings.CombinedIntegerVectorEncoding", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.ConditionActionEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
-  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances.DataAnalysis", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances.Views", "3.3")]
   public class HeuristicLabEncodingsCombinedIntegerVectorEncodingPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Plugin.cs.frame	(revision 9605)
@@ -25,6 +25,16 @@
   [Plugin("HeuristicLab.Encodings.ConditionActionEncoding", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.ConditionActionEncoding-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabEncodingsConditionActionEncodingPlugin : PluginBase {
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IAction.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IAction.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IAction.cs	(revision 9605)
@@ -34,4 +34,5 @@
     bool Match(IAction action);
     void SetTo(string value);
+    void SetTo(IGAssistNiche action);
 
     IEnumerable<int> GetPossibleActionPositions();
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IntAction.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IntAction.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/IntAction.cs	(revision 9605)
@@ -117,5 +117,11 @@
 
     public void SetTo(string value) {
-      currentAction = int.Parse(value);
+      SetToPosition(int.Parse(value));
+    }
+
+    public void SetTo(IGAssistNiche action) {
+      var castAction = action as IntAction;
+      if (castAction == null) throw new ArgumentException("action has to be IntAction");
+      SetToPosition(castAction.CurrentAction);
     }
 
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/StringAction.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/StringAction.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Action/StringAction.cs	(revision 9605)
@@ -122,5 +122,11 @@
 
     public void SetTo(string value) {
-      currentActionIndex = possibleFeatures.IndexOf(value);
+      SetToPosition(possibleFeatures.IndexOf(value));
+    }
+
+    public void SetTo(IGAssistNiche action) {
+      var castAction = action as StringAction;
+      if (castAction == null) throw new ArgumentException("action has to be IntAction");
+      SetToPosition(castAction.CurrentPosition);
     }
 
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/SmartDecisionListCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/SmartDecisionListCreator.cs	(revision 9605)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/SmartDecisionListCreator.cs	(revision 9605)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization.Operators.LCS;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.DecisionList {
+  [Item("SmartDecisionListCreator", "Description missing")]
+  [StorableClass]
+  public class SmartDecisionListCreator : DecisionListCreator {
+
+    [StorableConstructor]
+    protected SmartDecisionListCreator(bool deserializing) : base(deserializing) { }
+    protected SmartDecisionListCreator(SmartDecisionListCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public SmartDecisionListCreator()
+      : base() {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SmartDecisionListCreator(this, cloner);
+    }
+
+    protected override DecisionList Create(IRandom random, Rule sampleRule, int initialNumberOfRules, double oneProbability, ItemCollection<IDiscretizer> discretizers, IAction niche) {
+      var problemData = ProblemDataParameter.ActualValue;
+
+      List<Rule> rules = new List<Rule>();
+      for (int i = 0; i < initialNumberOfRules; i++) {
+        rules.Add(SmartRuleInitialization(problemData, random, sampleRule, initialNumberOfRules, oneProbability, discretizers, niche));
+      }
+      if (niche != null) {
+        return new DecisionList(rules, niche);
+      } else {
+        return new DecisionList(rules);
+      }
+    }
+
+    public static Rule SmartRuleInitialization(IDecisionListClassificationProblemData problemData, IRandom random,
+                                               Rule sampleRule, int initialNumberOfRules, double oneProbability,
+                                               ItemCollection<IDiscretizer> discretizers, IAction niche = null) {
+      IList<int> trainingIndicesOfOtherNiches = null;
+      if (niche != null) {
+        trainingIndicesOfOtherNiches =
+          problemData.TrainingIndices.Where(x => !problemData.FetchAction(x).SameNiche(niche)).ToList();
+      } else {
+        trainingIndicesOfOtherNiches = problemData.TrainingIndices.ToList();
+      }
+
+      var newRule = (Rule)sampleRule.Clone();
+      newRule.Randomize(random, oneProbability, discretizers);
+
+      int sample = random.Next(trainingIndicesOfOtherNiches.Count);
+      var input = problemData.FetchInput(trainingIndicesOfOtherNiches[sample]);
+      var action = problemData.FetchAction(trainingIndicesOfOtherNiches[sample]);
+
+      newRule.SetToMatchInput(input);
+      newRule.Action.SetTo(action);
+      return newRule;
+    }
+  }
+}
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/UniformRandomDecisionListCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/UniformRandomDecisionListCreator.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Creators/UniformRandomDecisionListCreator.cs	(revision 9605)
@@ -43,13 +43,21 @@
     }
 
-    protected override DecisionList Create(IRandom random, Rule sampleRule, int initialNumberOfRules, double oneProbability, ItemCollection<IDiscretizer> discretizers) {
+    protected override DecisionList Create(IRandom random, Rule sampleRule, int initialNumberOfRules, double oneProbability, ItemCollection<IDiscretizer> discretizers, IAction niche) {
       List<Rule> rules = new List<Rule>();
       for (int i = 0; i < initialNumberOfRules; i++) {
         var newRule = (Rule)sampleRule.Clone();
-        newRule.Randomize(random, oneProbability, discretizers);
+        if (niche != null) {
+          newRule.Randomize(random, oneProbability, discretizers, new List<IAction>() { niche });
+        } else {
+          newRule.Randomize(random, oneProbability, discretizers);
+        }
         rules.Add(newRule);
       }
 
-      return new DecisionList(rules);
+      if (niche != null) {
+        return new DecisionList(rules, niche);
+      } else {
+        return new DecisionList(rules);
+      }
     }
   }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Crossover/SinglePointCrossover.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Crossover/SinglePointCrossover.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Crossover/SinglePointCrossover.cs	(revision 9605)
@@ -48,5 +48,6 @@
 
     public static DecisionList Apply(IRandom random, DecisionList parent1, DecisionList parent2) {
-      if (!parent1.DefaultAction.Match(parent2.DefaultAction)) { throw new ArgumentException("Default action of parents have to match!"); }
+      if (parent1 == null && parent1 != parent2) { throw new ArgumentException("Either both parents have a default action or none does."); }
+      if (parent1.DefaultAction != null && !parent1.DefaultAction.Match(parent2.DefaultAction)) { throw new ArgumentException("Default action of parents have to match!"); }
 
       int rulesP1 = random.Next(0, parent1.Rules.Count());
@@ -64,4 +65,7 @@
       }
 
+      if (parent1.DefaultAction == null) {
+        return new DecisionList(rules);
+      }
       return new DecisionList(rules, parent1.DefaultAction);
     }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs	(revision 9605)
@@ -44,4 +44,8 @@
     }
 
+    public double Length {
+      get { return 1 + rules.Sum(r => r.Length); }
+    }
+
     // default rule (action) is part of the rule set size
     public int RuleSetSize {
@@ -53,5 +57,5 @@
     protected DecisionList(DecisionList original, Cloner cloner)
       : base(original, cloner) {
-      defaultAction = original.DefaultAction;
+      defaultAction = cloner.Clone(original.DefaultAction);
       rules = new List<Rule>(original.rules.Count);
       foreach (var rule in original.Rules) {
@@ -124,19 +128,4 @@
     }
 
-    public void SetNiche(IRandom random, IGAssistNiche niche) {
-      var action = niche as IAction;
-      if (action == null) {
-        throw new ArgumentException("Niche has to be an action");
-      }
-      if (Niche != null) {
-        throw new ArgumentException("Niche has already been set. It cannot be set again.");
-      }
-      defaultAction = action;
-      var except = new List<IAction>() { action };
-      foreach (var rule in rules.Where(x => x.Action.SameNiche(niche))) {
-        rule.Action.Randomize(random, except);
-      }
-    }
-
     public void ApplySplit(IRandom random, double probability) {
       foreach (var rule in rules) {
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListCreator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListCreator.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListCreator.cs	(revision 9605)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -52,4 +53,7 @@
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
     }
+    public ILookupParameter<IGAssistNiche> GAssistNicheParameter {
+      get { return (ILookupParameter<IGAssistNiche>)Parameters["GAssistNiche"]; }
+    }
     #endregion
 
@@ -67,13 +71,19 @@
       Parameters.Add(new LookupParameter<DecisionList>("DecisionList", ""));
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new ValueLookupParameter<IAction>("DefaultAction", ""));
+      Parameters.Add(new LookupParameter<IGAssistNiche>("GAssistNiche", ""));
     }
 
     public override IOperation Apply() {
-      DecisionListParameter.ActualValue = Create(RandomParameter.ActualValue, ProblemDataParameter.ActualValue.SampleRuleParameter.Value, InitialNumberOfRulesParameter.ActualValue.Value, OneProbabilityParameter.ActualValue.Value, DiscretizersParameter.ActualValue);
+      if (GAssistNicheParameter.ActualValue != null && !(GAssistNicheParameter.ActualValue is IAction)) throw new ArgumentException("GAssistNiche has to be a IAction.");
+      DecisionListParameter.ActualValue = Create(RandomParameter.ActualValue,
+                                              ProblemDataParameter.ActualValue.SampleRuleParameter.Value,
+                                              InitialNumberOfRulesParameter.ActualValue.Value,
+                                              OneProbabilityParameter.ActualValue.Value,
+                                              DiscretizersParameter.ActualValue,
+                                              (IAction)GAssistNicheParameter.ActualValue);
       return base.Apply();
     }
 
-    protected abstract DecisionList Create(IRandom random, Rule sampleRule, int initialNumberOfRules, double oneProbability, ItemCollection<IDiscretizer> discretizers);
+    protected abstract DecisionList Create(IRandom random, Rule sampleRule, int initialNumberOfRules, double oneProbability, ItemCollection<IDiscretizer> discretizers, IAction niche);
   }
 }
Index: branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs
===================================================================
--- branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs	(revision 9494)
+++ branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs	(revision 9605)
@@ -49,8 +49,14 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
+    public ILookupParameter<DoubleValue> LengthParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Length"]; }
+    }
     public IValueLookupParameter<IDecisionListClassificationProblemData> ProblemDataParameter {
       get { return (IValueLookupParameter<IDecisionListClassificationProblemData>)Parameters["ProblemData"]; }
     }
 
+    public IValueLookupParameter<BoolValue> UseMDLParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["UseMDL"]; }
+    }
     public ILookupParameter<MDLCalculator> MDLCalculatorParameter {
       get { return (ILookupParameter<MDLCalculator>)Parameters["MDLCalculator"]; }
@@ -73,4 +79,7 @@
       get { return (ILookupParameter<ItemList<ItemList<IntValue>>>)Parameters["Strata"]; }
     }
+    public IValueLookupParameter<BoolValue> MaximizationParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
     #endregion
 
@@ -90,5 +99,7 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("SizePenaltyMinRules", ""));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("Length", ""));
       Parameters.Add(new ValueLookupParameter<IDecisionListClassificationProblemData>("ProblemData", ""));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("UseMDL", "", new BoolValue(true)));
       Parameters.Add(new LookupParameter<MDLCalculator>("MDLCalculator", ""));
       Parameters.Add(new LookupParameter<IntValue>("Iterations", ""));
@@ -97,4 +108,11 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("RuleDeletionMinRules", "", new IntValue(12)));
       Parameters.Add(new ValueLookupParameter<ItemList<ItemList<IntValue>>>("Strata", ""));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "", new BoolValue(false)));
+
+      UseMDLParameter.Value.ValueChanged += UseMDLParameter_ValueChanged;
+    }
+
+    private void UseMDLParameter_ValueChanged(object sender, System.EventArgs e) {
+      MaximizationParameter.Value.Value = !UseMDLParameter.Value.Value;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -103,6 +121,4 @@
 
     public override IOperation Apply() {
-      double penalty = 1;
-
       var strata = StrataParameter.ActualValue;
       int iteration = IterationsParameter.ActualValue.Value;
@@ -125,4 +141,5 @@
       var estimated = dl.Evaluate(input, out aliveRules, out theoryLength);
 
+      double penalty = 1;
       if (aliveRules.Count < SizePenaltyMinRulesParameter.ActualValue.Value) {
         penalty = (1 - 0.025 * (SizePenaltyMinRulesParameter.ActualValue.Value - aliveRules.Count));
@@ -132,5 +149,10 @@
 
       double accuracy = DecisionListSolution.CalculateAccuracy(actions, estimated);
-      QualityParameter.ActualValue = new DoubleValue(MDLCalculatorParameter.ActualValue.CalculateFitness(theoryLength, accuracy) / penalty);
+      if (UseMDLParameter.ActualValue.Value) {
+        QualityParameter.ActualValue =
+          new DoubleValue(MDLCalculatorParameter.ActualValue.CalculateFitness(theoryLength, accuracy) / penalty);
+      } else {
+        QualityParameter.ActualValue = new DoubleValue(accuracy * accuracy * penalty);
+      }
 
       if (iteration >= IterationRuleDeletionParameter.ActualValue.Value) {
@@ -141,4 +163,6 @@
         }
       }
+
+      LengthParameter.ActualValue = new DoubleValue(dl.Length * aliveRules.Count / dl.RuleSetSize);
       return base.Apply();
     }
